package ac.essex.ooechs.imaging.commons.evolved;

import ac.essex.ooechs.imaging.commons.HaarRegions;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 09-Oct-2006
 * @version 1.0
 */
public class FaceDetectorA extends ObjectDetector {

    public double calculate( HaarRegions image ) {
		double func_1 = image.getFourRectangleFeature(2, 5, 2, 2, HaarRegions.SECOND_SHAPE);
		double func_2 = image.getFourRectangleFeature(5, 0, 3, 4, HaarRegions.SECOND_SHAPE);
		boolean func_3 = func_1 < func_2;
		double func_4 = image.getThreeRectangleFeature(0, 3, 3, 5, HaarRegions.VERTICALLY_ADJACENT);
		double func_5 = image.getFourRectangleFeature(2, 5, 2, 2, HaarRegions.SECOND_SHAPE);
		boolean func_6 = func_4 < func_5;
		double func_7 = image.getTwoRectangleFeature(2, 2, 1, 2, HaarRegions.HORIZONTALLY_ADJACENT, HaarRegions.SECOND_SHAPE);
		double func_8 = image.getFourRectangleFeature(1, 6, 3, 4, HaarRegions.SECOND_SHAPE);
		boolean func_9 = func_7 > func_8;
		double func_10 = image.getFourRectangleFeature(1, 3, 2, 2, HaarRegions.FIRST_SHAPE);
		boolean func_11 = 8.932817687446034 > func_10;
		double func_12 = image.getThreeRectangleFeature(1, 7, 4, 4, HaarRegions.HORIZONTALLY_ADJACENT);
		double func_13 = -12.05545969008913 == 0 ? 0 : 255.9269212868306 / -12.05545969008913;
		double func_14 = func_13 == 0 ? 0 : func_12 / func_13;
		double func_15 = image.getFourRectangleFeature(1, 2, 1, 1, HaarRegions.SECOND_SHAPE);
		boolean func_16 = func_14 < func_15;
		double func_17 = func_16? -1 : 1;
		double func_18 = false? -1 : func_17;
		double func_19 = func_11? -1 : func_18;
		boolean func_20 = true == false;
		double func_21 = false? -1 : -1;
		double func_22 = func_20? 1 : func_21;
		double func_23 = func_9? func_19 : func_22;
		double func_24 = false? 0 : -1;
		double func_25 = func_6? func_23 : func_24;
		boolean func_26 = -251.06121708721017 > -103.20935375482013;
		double func_27 = false? -1 : -1;
		double func_28 = func_26? -1 : func_27;
		return func_3? func_25 : func_28;
        }

}
