package ac.essex.ooechs.imaging.commons.multichannel;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 26-Nov-2007
 * @version 1.0
 */
public class MultiChannelPixelData {

    protected float[][] pixelData;
    protected int classID;

    public MultiChannelPixelData(int numChannels, int classID) {
        pixelData = new float[numChannels][];
        this.classID = classID;
    }

    public void addData(float[] data, int channel) {
        pixelData[channel] = data;
    }

    public float[] getData(int channel) {
        return pixelData[channel];
    }
    
    public double getData(int channel, int index) {
        return pixelData[channel][index];
    }

    public int getClassID() {
        return classID;
    }
    
}
