package ac.essex.ooechs.imaging.commons.segmentation;

import ac.essex.ooechs.imaging.commons.PixelLoader;
import ac.essex.ooechs.imaging.commons.ConvolutionMatrix;
import ac.essex.ooechs.imaging.commons.StatisticsSolver;

import java.awt.*;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 19-Feb-2008
 * @version 1.0
 */
public class SpeedTest {

    public static void main(String[] args) throws Exception {



        ConvolutionMatrix matrix = new ConvolutionMatrix(ConvolutionMatrix.LAPLACIAN);

        PixelLoader image = new PixelLoader("/home/ooechs/Desktop/Documents/Papers/Pipelines/data/scaled_Frame181.jpg");

        StatisticsSolver solver = new StatisticsSolver();
        for (int i = 0; i <= 20; i++) {
            long start = System.currentTimeMillis();
            image.getProcessedImage(PixelLoader.VARIANCE);
            image.varianceCache = null;
            long stop = System.currentTimeMillis();
            int time = (int) (stop - start);
            if (i > 0) {
            solver.addData(time);
            System.out.println("T=" + time);
            }
        }

        System.out.println("MEAN: " + solver.getMean() + " VAR: " + solver.getStandardDeviation());


    }



}
