package ac.essex.ooechs.imaging.commons.util;

import java.io.File;
import java.io.FilenameFilter;
import java.util.Vector;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 05-Oct-2006
 * @version 1.0
 */
public class ImageFilenameFilter implements FilenameFilter {

    public boolean accept(File dir, String name) {
        return isImage(name);
    }

    public static boolean isImage(File f) {
        return isImage(f.getName());
    }

    public static boolean isImage(String filename) {

        filename = filename.toLowerCase();

        if (filename.endsWith(".bmp")) return true;
        if (filename.endsWith(".jpg")) return true;
        if (filename.endsWith(".gif")) return true;
        if (filename.endsWith(".png")) return true;

        return false;

    }

    public static Vector<File> getImages(File directory) {
        File[] files = directory.listFiles(new ImageFilenameFilter());
        Vector<File> imageList = new Vector<File>(20);
        for (int i = 0; i < files.length; i++) {
            File file = files[i];
            if (file.isDirectory()) {
                imageList.addAll(getImages(file));
            } else {
                imageList.add(file);
            }
        }
        return imageList;
    }

}
