package ac.essex.ooechs.imaging.commons.window.TheMondayProject;

/**
 * Representds data with its associated filename
 *
 * @author Olly Oechsle, University of Essex, Date: 15-Apr-2008
 * @version 1.0
 */
public class WindowData implements Comparable {

    protected String file;
    public double[] data;
    public int classID;
    
    public double rank = 0;

    public WindowData(String file, double[] data, int classID) {
        this.file = file;
        this.data = data;
        this.classID = classID;
    }

    public void print() {
            System.out.print(classID + ", new double[]{");

        for (int i = 0; i < data.length; i++) {
            double v = data[i];
            System.out.print(v);
            if (i < data.length - 1) {
                System.out.print(",");
            }
        }

        System.out.println("}");
    }

    /**
     * Compares this object with the specified object for order.  Returns a
     * negative integer, zero, or a positive integer as this object is less
     * than, equal to, or greater than the specified object.<p>
     */
    public int compareTo(Object o) {
        WindowData other = (WindowData) o;
        if (this.rank < other.rank) return -1;
        if (this.rank > other.rank) return 1;
        return 0;
    }           

}
